#include <iostream>

using namespace std;

template < typename T1, typename T2 > inline void chkmax(T1 & x, T2 y) {
	if (x < y) x = y;
}

const int N = 2e3 + 5;
const int INF = 1e9;

int n, m;
int cost[N * 2], level[N], salary[N];
int dp[N][2][N * 4];

int get_delta(int min_value, int mask) {
	int ans = cost[min_value];
	for (int i = 0;
		(mask >> i) & 1; ++i) {
		ans += cost[min_value + i + 1];
	}
	return ans;
}

string f(int mask) {
	string s = "";
	for (int i = 6; i--;) {
		s += ((mask >> i) & 1) + '0';
	}
	return s;
}

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) cin >> level[i];
	for (int i = 0; i < n; ++i) cin >> salary[i];
	for (int i = 1; i <= n + m; ++i) cin >> cost[i];

	int mlog = 1;
	while ((1 << mlog) <= n) ++mlog;
	int max_mask = (1 << mlog) - 1;

	for (int i = 0; i <= m; ++i) {
		for (int mask = 0; mask <= max_mask; ++mask) {
			dp[i][0][mask] = dp[i][1][mask] = -INF;
		}
		dp[i][0][0] = dp[i][1][0] = 0;
	}

	for (int i = 0; i < n; ++i) {
		for (int mask = max_mask - 1; mask >= 0; --mask) {
			int delta = get_delta(level[i], mask);
			chkmax(dp[level[i]][0][mask + 1], dp[level[i]][0][mask] + delta - salary[i]);
		}	
		int delta = get_delta(level[i], max_mask);
		chkmax(dp[level[i]][0][0], dp[level[i]][1][max_mask] + delta - salary[i]);
		for (int mask = max_mask - 1; mask >= 0; --mask) {
			int delta = get_delta(level[i], mask);
			chkmax(dp[level[i]][1][mask + 1], dp[level[i]][1][mask] + delta - salary[i]);
		}
		for (int j = level[i]; j > 1; --j) {
			int lg = min(mlog, level[i] - j);
			for (int mask = 0; mask <= max_mask; mask += (1 << lg)) {
				if (mask & (1 << (mlog - 1))) {
					int nmask = (mask ^ (1 << (mlog - 1))) << 1;
					chkmax(dp[j - 1][0][nmask], dp[j][0][mask]);
					chkmax(dp[j - 1][1][nmask], dp[j][0][mask]);
					chkmax(dp[j - 1][1][nmask], dp[j][1][mask] + cost[j + mlog]);
				} else {
					int nmask = mask << 1;
					chkmax(dp[j - 1][0][nmask], dp[j][0][mask]);
					chkmax(dp[j - 1][1][nmask], dp[j][0][mask]);
				}
			}
		}
	}

	int ans = 0;
	for (int i = 0; i <= max_mask; ++i) {
		chkmax(ans, dp[1][0][i]);
	}
	cout << ans << '\n';
}
