#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <sstream>
#include <deque>
#include <queue>
#include <random>
#include <cassert>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define FIXED cout << fixed << setprecision(12)
#define RANDOM srand(94385)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define f first
#define s second
#define hashmap unordered_map
#define hashset unordered_set
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) signed(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.f >> p.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline T sorted(T a) { sort(a); return a; }

const int N = 2020;
const int LOG = 10;

int dp[N][1 << LOG][2]; // min value, mask of left elements, need move

inline int cut(int mask) {
    return mask & ((1 << LOG) - 1);
}

inline int addcut(int mask, int v, int add) {
    return cut((mask << (v - add)) + 1);
}

bool bigmove(int mask, int v, int add) {
    return add == v && mask == (1 << LOG) - 1;
}

vector<int> c;

inline int cost(int mask, int v, int add) {
    if (add < v) return c[add];
    int ans = 0;
    while (add < sz(c) - 1 && ((mask >> (add - v)) & 1)) {
        ans += c[add];
        ++add;
    }
    return ans + c[add];
}

signed main() {
    FAST; FIXED; RANDOM;
    int n, m;
    cin >> n >> m;
    vector<int> level(n), salary(n);
    c = vector<int>(n + m);
    cin >> level >> salary >> c;
    for (auto &i : level) --i;
    for (int i = 0; i < N; ++i)
        for (int mask = 0; mask < (1 << LOG); ++mask)
            for (int flag = 0; flag < 2; ++flag)
                dp[i][mask][flag] = -mod;
    for (int i = 0; i < N; ++i)
        dp[i][0][0] = 0;
    vector<int> mx[2];
    mx[0] = mx[1] = vector<int>(N, -mod);
    mx[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        int v = level[i];
        vector<vector<int>> upd;
        for (int past = v + 1; past < v + 3; ++past)
            for (int mask = 0; mask < (1 << LOG); ++mask) {
                upd.pb({v, addcut(mask, past, v), 0, dp[past][mask][0] + c[v] - salary[i]});
            }
        for (int mask = 0; mask < (1 << LOG); ++mask) {
            upd.pb({v, addcut(mask, v, v), 0, dp[v][mask][0] + cost(mask, v, v) - salary[i]});
        }
        for (int past = v + 3; past < N; ++past) {
            upd.pb({v, addcut(0, v, v), 0, mx[0][past] + cost(0, v, v) - salary[i]});
        }
        /*for (int mask = 0; mask < (1 << LOG); ++mask) {
            upd.pb({v, addcut(mask, v, v), 1, dp[v][mask][0] + cost(mask, v, v)});
        }
        for (int mask = 0; mask < (1 << LOG); ++mask) {
            upd.pb({v, addcut(mask, v, v), 0, dp[v + 1][mask][1] + c[v] - salary[i]});
            
        }*/
        for (auto i : upd) {
            checkmax(dp[i[0]][i[1]][i[2]], i[3]);
            checkmax(mx[i[2]][i[0]], i[3]);
        }
        /*if (v < N - 1) {
            for (int mask = 0; mask < (1 << LOG); ++mask) {
                checkmax(dp[v][0][0], dp[v + 1][mask][1] + c[v]);
            }
        }*/
    }
    int ans = 0;
    for (int i = 0; i < N; ++i)
        for (int mask = 0; mask < (1 << LOG); ++mask)
            checkmax(ans, dp[i][mask][0]);
    cout << ans;
    return 0;
}
